;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
.include "sys/globalsys.h.s"

;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA

;;
;; Start of _CODE area
;; 
.area _CODE

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.
;;

.globl cpct_waitVSYNC_asm
.globl jump_table
.globl update_physics
.globl update_render
.globl update_input
.globl sys_tile_collision_update
.globl sys_render_init
.globl menu_manager
.globl change_palette

.globl update_enemies





.globl ai_control
.globl _spr_key_0
.globl _spr_key2_0
.globl _spr_key3_0


size_enemy:: .db #17
max_num_enemies:: .db #5

enemies:: .ds #85 ;;size_enemy * max_num_enemies
end_enemies:: .db #0x00





player:: .db #0, #0           ;  X, Y
         .dw #0x0000          ;  PUNTERO A POSICION PREVIA EN MEMORIA(no se si se quitara, seguramente si, sustituir por puntero a sprite)
         .db #0x00            ;  INDICE DE SALTO INICIAL (0xFF -> salto no activo)
         .db #0x00, #0x00     ;  VELOCIDADES EN 'X' e 'Y'
         .db #4, #24          ;  WIDTH, HEIGHT
         .dw #0x0000          ;  Sprite Pointer
         .db #3

;para las colisiones
key_map6::     .db #67, #18       ;  X, Y
               .db #2, #16       ;  Width, Height
               .db #1            ;key_status
               .dw #_spr_key_0

key_map8::     .db #13, #165       ;  X, Y
               .db #2, #16         ;  Width, Height
               .db #1   
               .dw #_spr_key2_0

key_map11::    .db #59, #17       ;  X, Y
               .db #2, #16         ;  Width, Height
               .db #1  
               .dw #_spr_key3_0


;to exit the house
exit_door:: .db #68, #100       ;  X, Y
            .db #6, #30       ;  width, height

;Falta etiqueta de gravedad, para aumentar la posicion en 'y' en el caso de que no haya un "tile colisionable" debajo
;Falta otra etiqueta de velocidad de gravedad que aumente con cada iteracion en el que el bit de gravedad este activo
;estos bits se usan al comprobar las colisiones con los tiles, 

number_of_maps = 9



map_index:: .db #0x00


gravity::    .db #0x00   ;0 -> player jumping or in a platform

vgravity::   .db #0x00   ;velocity to add to vy



;map size = 8

death_screen:: .dw #0x0000    ;sprite pointer

end_game::  .dw #0x0000    ;sprite pointer



;Jump Table for short jumps
jump_table:: .db #-6, #-6, #-4, #-4, #-4, #-4, #-2, #00, #00, #00, #2, #2, #4, #4, #4, #4, #4, #6, #0x80


_main::
   


   call sys_render_init

   jp  menu_manager


   loop:
      jr loop
