;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "enemy.h.s"
.include "../sys/globalsys.h.s"





;;Para las pruebas de colision. Quitar
_activate_collision::
    push ix
    ld ix, #player
    call deleteAndResetPlayer
    pop ix
    ret

update_enemies::
    ld hl, #collisions_enemies
    call _man_enemy_forall

    ret

    ;ld e, #0
    ;ld ix, #player
;
    ;ld a, 0(iy)     ;x-> key_map6
    ;add a, 2(iy)  ;width -> key_map6
    ;sub a, playerx(ix)
;
    ;ret c
;
    ;ld a, playerx(ix)       ;x->player
    ;add a, playerwidth(ix)  ;x->width
    ;sub a, 0(iy)            ; x->player
;
    ;ret c
;
    ;ld a, 1(iy)             ; y->key_map6
    ;add a, 3(iy) ; height->key_map6
    ;sub a, playery(ix)      ; y->player
;
    ;ret c
;
    ;ld a, playery(ix)
    ;add a, playerheight(ix)
    ;sub a, 1(iy)
;
    ;ret c
;
    ;ld e, #1
;
    ;ret

collisions_enemies::
    ;;jr .
    push de

    ld iy, #player

    ld a, 0(ix)     ; x enemigo
    add a, 5(ix)    ;ancho enemigo
    sub a, playerx(iy) ;0

    jr c, _end

    ld a, playerx(iy)
    add a, playerwidth(iy) ;5    ;2(ix)
    sub a, 0(ix) 

    jr c, _end
    
    ld a, 1(ix)     ;y -> enemy
    add a, 6(ix)    ;altura -> enemy
    sub a, playery(iy)

    jr c, _end
    
    ld a, playery(iy)
    add a, playerheight(iy) ;3(ix)
    sub a, 1(ix)            ;y -> enemy

    jr c, _end

    call _activate_collision

    _end:
        pop hl
        jp (hl)





ai_control::
    ;;ret
    ld hl, #ai_control_update
    call _man_enemy_forall
    ret

ai_control_update::
    push de

    ;;jr .

    ;;ld hl, #_end_ai
    ;;push hl

    ld a, e_ia_state(ix)

    cp #stand_by_state
    jr z, ai_stand_by
    cp #move_to_state
    ;;jr z, ai_move_to
    jp z, ai_collision_route
    cp #patrol_state
    ;;jr z, ai_patrol
    jp z, ai_patrol_collisions

    _end_ai:
        pop hl
        jp (hl)
        ret

ai_stand_by::
    ld a, next_e_ia_x(ix)
    ld e_ia_x(ix), a
    ld a, next_e_ia_y(ix)
    ld e_ia_y(ix), a

    ld a, e_x(ix)
    ld next_e_ia_x(ix), a
    ld a, e_y(ix)
    ld next_e_ia_y(ix), a

    ld e_ia_state(ix), #move_to_state

    ;;pop hl
    ;;;;jr _end_ai
    ;;jp (hl)

    pop hl
    jp (hl)
    ret

blank_enemy:
;;Enemigo 1
        .db #0, #0      ;  X, Y
        .db #0           ;  INDICE DE SALTO INICIAL (0xFF -> salto no activo)
        .db #0, #0x00     ;  VELOCIDADES EN 'X' e 'Y'
        .db #0x00, #0x00     ;  WIDTH, HEIGHT
        .db #0, #0     ;  DIRECCION IA
        .db #0, #0     ;  DIRECCION IA SIGUIENTE
        .db #0               ;  ESTADO IA
        .db #0               ;  ESTADO ANTERIOR IA
        .db #0               ;  MOVIMIENTO EN EJE. X = 0 | Y = 1
        .db #0
        .dw #0x0000
        .dw #0x0000

;limpia el array de enemigos, y coloca los del nivel
.globl map_index
.globl enemies
.globl enemigos_mapa_2

set_map_enemies::
    call clear_enemies
    ld a, (map_index)
    cp #2
    jr z, setMap2
    cp #3
    jr z, setMap3
    cp #4
    jr z, setMap4
    cp #5
    jr z, setMap5
    cp #6
    jr z, setMap6
    cp #7
    jr z, setMap7
    cp #8
    jr z, setMap8
    cp #10
    jr z, setMap10
    cp #11
    jr z, setMap11
    ret
    ;Dependiendo del mapa se hará un set u otro




clear_enemies::
    ld de, #enemies
    ld hl, #blank_enemy
    ld bc, #19
    ldir
    ;DE = enemies + 17
    ld hl, #blank_enemy
    ld bc, #19
    ldir
    ld hl, #blank_enemy
    ld bc, #19
    ldir


    ret


setMap2:
    ld de, #enemies
    ld hl , #enemigos_mapa_2
    ld bc, #19
    ldir
    ret



setMap3:
    ld de, #enemies
    ld hl , #enemigos_mapa_3
    ld bc, #38
    ldir
    ret

setMap4:
    ld de, #enemies
    ld hl , #enemigos_mapa_4
    ld bc, #38
    ldir
    ret

setMap5:
    ld de, #enemies
    ld hl , #enemigos_mapa_5
    ld bc, #38
    ldir
    ret

setMap6:
    ld de, #enemies
    ld hl , #enemigos_mapa_6
    ld bc, #38
    ldir
    ret

setMap7:
    ld de, #enemies
    ld hl , #enemigos_mapa_7
    ld bc, #38
    ldir
    ret

setMap8:
    ld de, #enemies
    ld hl , #enemigos_mapa_8
    ld bc, #38
    ldir
    ret

setMap10:
    ld de, #enemies
    ld hl , #enemigos_mapa_10
    ld bc, #38
    ldir
    ret

setMap11:
    ld de, #enemies
    ld hl , #enemigos_mapa_11
    ld bc, #38
    ldir
    ret
    
    























ai_patrol_collisions::
    ;;jr .

    ;;ld a, e_vx(ix)
    ;;bit 7, a
    
    ld a, e_ia_direction(ix)
    cp #2
    jr z, ai_set_izquierda
    ;;jr ai_set_derecha


    ai_set_derecha:
        ;;jr . 
        ;set 7, e_vx(ix)
        ;set 7, e_vy(ix)
        ld e_ia_direction(ix), #2
        
        jr ai_fin_set_collision

    ai_set_izquierda::
        ;;jr .
        ;res 7, e_vx(ix)
        ;res 7, e_vy(ix)

        ld e_ia_direction(ix), #1
        
        jr ai_fin_set_collision

    ai_fin_set_collision::
        ld e_ia_state(ix), #move_to_state
        ld e_ia_previous_state(ix), #patrol_state

        pop hl
        jp (hl)
        ret

    ret

ai_collision_route::
    ;;jr .
    ;;Falta comprobar si la velocidad es positiva o negativa
    ld a, e_ia_type(ix)
    cp #1
    jr z, ai_Axis_y
    jr ai_Axis_x


    

ai_Axis_x::
    ld b, e_x(ix)
    ld a, e_ia_direction(ix)
    cp #2
    jr z, movimiento_izquierda

    movimiento_derecha:
        ld a, b
        ld b, e_w(ix)
        inc b
        add b
        ld b, a
        
        ;;inc b   ;;Cambiar por la anchura del enemigo
        ;;inc b
        ;;inc b
        jr comprobacion_X
    movimiento_izquierda:
        ld a, b
        ld b, e_w(ix)
        inc b
        sub b
        ld b, a

        ;dec b   ;;Cambiar por la anchura del enemigo
        ;dec b
        ;dec b

    comprobacion_X:
        ld a, e_y(ix)
        ld c, #1
        call ai_checkEnemyPosition_X
        ld a, e   ;en e tengo 0 o 1, dependiendo de si ha habido colision, si ya ha habido colision, no hace falta seguir mirando
        cp #0
        jr z, ai_collision   ;;Cambiar direccion del enemigo
        jr ai_no_collision

ai_Axis_y::
    ld a, e_ia_direction(ix)
    cp #2
    jr z, movimiento_abajo

    movimiento_arriba:
        ld a, e_y(ix)
        ld b, e_h(ix)
        inc b
        add b
        jr comprobacion_Y
        
    movimiento_abajo:
        ld a, e_y(ix)
        ld b, e_h(ix)
        inc b
        sub b

    comprobacion_Y:
        ld c, #0
        call ai_checkEnemyPosition_Y
        ld a, e   ;en e tengo 0 o 1, dependiendo de si ha habido colision, si ya ha habido colision, no hace falta seguir mirando
        cp #0
        jr z, ai_collision   ;;Cambiar direccion del enemigo
        jr ai_no_collision



    
ai_no_collision::
    ;;jr .

    ;;ld a, e_vx(ix)
    ;;bit 7, a

    ld a, e_ia_direction(ix)
    cp #2
    jr z, ai_izquierda


    ai_derecha:
        ld a, e_x(ix)
        add e_vx(ix)
        ld e_x(ix), a

        ld a, e_y(ix)
        add e_vy(ix)
        ld e_y(ix), a
        jr ai_fin_no_collision

    ai_izquierda::
        ld a, e_x(ix)
        sub e_vx(ix)
        ld e_x(ix), a

        ld a, e_y(ix)
        sub e_vy(ix)
        ld e_y(ix), a
        jr ai_fin_no_collision

    ai_fin_no_collision::
        pop hl
        jp (hl)
        ret
    
    ret
    
ai_collision::
    ld a, e_ia_previous_state(ix)
    ld e_ia_state(ix), a
    ld e_ia_previous_state(ix), #move_to_state

    pop hl
    jp (hl)
    ret

ai_checkEnemyPosition_X::
    ;;ld a, e_y(ix)
    add c
    srl a ;; |  
    srl a ;; | A = A / 8 
    srl a ;; |   
    ;; multiplicacion
    ld h, #0
    ld l, a
    add hl, hl ;; *2
    add hl, hl ;; *4
    push hl
    add hl, hl ;; *8
    add hl, hl ;; *16
    pop de
    ;; Multiplicación por 20 = *16 + *4
    add hl, de
    ld a, b
    ;; calculamos tx
    ;ld a, playerx(ix)
    ;; división entre 4
    srl a
    srl a
    ;; esto es una macro que utiliza él
    ;;add__hl_a ;; hl = ty * tw + tx (faltaría sumar el tilemap)
    ld d, #0x00
    ld e, a
    add hl, de
    push hl
    call givememap
    pop hl
    add hl, de
    ;; HL = tilemapposinic + ty * tw + tx
    ld a, (hl) ;load tile number
    and #0b11100000
    jr z, ai_collision
    ;;ret z
    ld e, #0x01

    ret



ai_checkEnemyPosition_Y::
    ;;ld a, e_y(ix)
    srl a ;; |  
    srl a ;; | A = A / 8 
    srl a ;; |   
    ;; multiplicacion
    ld h, #0
    ld l, a

    add hl, hl ;; *2
    add hl, hl ;; *4
    push hl
    add hl, hl ;; *8
    add hl, hl ;; *16
    pop de

    ;; Multiplicación por 20 = *16 + *4
    add hl, de
    ld c, a

    ld a, e_x(ix)
    ;; calculamos tx
    ;ld a, playerx(ix)
    ;; división entre 4
    srl a
    srl a

    push hl
    call givememap
    pop hl

    add hl, de

    ;;push hl

    ld a, e_x(ix)
    srl a
    srl a

    ld d, #0x00
    ld e, a
    add hl, de

    ld a, (hl)
    and #0b11100000
    jr z, ai_collision
    ;;ret z

    ld e, #0x01
    ret

























;ai_Axis_x:
    ;    ;;ld a, e_vx(ix)
    ;    ;;bit 7, a
    ;    ld b, e_x(ix)
    ;    ;;ld c, e_ia_direction(ix)
    ;    ;;cp c, #2
    ;    ld a, e_ia_direction(ix)
    ;    cp #2
    ;    jr z, movimiento_izquierda
    ;    ;inc b   ;;Cambiar por la anchura del enemigo
    ;    ;inc b
    ;    ;inc b
;
    ;    movimiento_derecha:
    ;        inc b   ;;Cambiar por la anchura del enemigo
    ;        inc b
    ;        inc b
    ;        jr comprobacion_X
    ;    movimiento_izquierda:
    ;        dec b   ;;Cambiar por la anchura del enemigo
    ;        dec b
    ;        dec b
;
    ;    comprobacion_X:
    ;        ld a, e_y(ix)
    ;        ld c, #0
    ;        call ai_checkEnemyPosition_X
    ;        ld a, e   ;en e tengo 0 o 1, dependiendo de si ha habido colision, si ya ha habido colision, no hace falta seguir mirando
    ;        cp #0
    ;        jr z, ai_collision   ;;Cambiar direccion del enemigo
    ;        jr ai_no_collision







;;ai_move_to::
;;    ld b, #0
;;
;;    ld a, e_ia_x(ix)
;;    sub e_x(ix)
;;    jr nc, greater_or_equal_x
;;
;;    lesser_x:
;;        ;;jr .
;;        ld a, e_x(ix)
;;        sub e_vx(ix)
;;        ld e_x(ix), a
;;        jr endif_x
;;
;;    greater_or_equal_x:
;;        jr z, arrived_x
;;        ld a, e_x(ix)
;;        add e_vx(ix)
;;        ld e_x(ix), a
;;        jr endif_x
;;
;;    arrived_x:
;;        inc b
;;
;;    endif_x:
;;        
;;
;;    ld a, e_ia_y(ix)
;;    sub e_y(ix)
;;    jr nc, greater_or_equal_y
;;
;;    lesser_y:
;;        ld a, e_y(ix)
;;        sub e_vy(ix)
;;        ld e_y(ix), a
;;        jr endif_y
;;
;;    greater_or_equal_y:
;;        jr z, arrived_y
;;        ld a, e_y(ix)
;;        add e_vy(ix)
;;        ld e_y(ix), a
;;        jr endif_y
;;
;;    arrived_y:
;;        inc b
;;        ;sub b, #2
;;        ld a, #2
;;        cp b
;;        jr z, change_state
;;        jr endif_y
;;    
;;    change_state: 
;;        ld a, e_ia_previous_state(ix)
;;        ld e_ia_state(ix), a
;;        ld e_ia_previous_state(ix), #move_to_state
;;
;;    endif_y:
;;
;;    ;;pop hl
;;    ;;;;jr _end_ai
;;    ;;jp (hl)
;;
;;    pop hl
;;    jp (hl)
;;    ret
;;
;;    ret
;;
;;ai_patrol::
;;    ;;ld a, e_ia_step_patrol(ix)
;;    ;;cp #0
;;    ;;jr z, _step0
;;    ;;cp #1
;;    ;;jr z, _step1
;;
;;
;;    ld a, next_e_ia_x(ix)
;;    ld e_ia_x(ix), a
;;    ld a, next_e_ia_y(ix)
;;    ld e_ia_y(ix), a
;;
;;    ld a, e_x(ix)
;;    ld next_e_ia_x(ix), a
;;    ld a, e_y(ix)
;;    ld next_e_ia_y(ix), a
;;
;;
;;    ;_step0:
;;    ;    ld a, next_e_ia_x(ix)
;;    ;    ld e_ia_x(ix), a
;;    ;    ld a, next_e_ia_y(ix)
;;    ;    ld e_ia_y(ix), a
;;    ;    jr _update_states
;;
;;    ;step1:
;;    ;    ld a, e_x(ix)
;;    ;    ld next_e_ia_x(ix), a
;;    ;    ld a, e_y(ix)
;;    ;    ld next_e_ia_y(ix), a
;;    ;    jr _update_states
;;
;;    ld e_ia_state(ix), #move_to_state
;;    ld e_ia_previous_state(ix), #patrol_state
;;
;;    ;;pop hl
;;    ;;;;jr _end_ai
;;    ;;jp (hl)
;;
;;    pop hl
;;    jp (hl)
;;    ret






    ;; esto es una macro que utiliza él
    ;;add__hl_a ;; hl = ty * tw + tx (faltaría sumar el tilemap)
    ;ld d, #0x00
    ;ld e, a
    ;add hl, de
    ;ld de, #_pruebacollision ;;Mapa: Hay que actualizar
    ;add hl, de
    ;;; HL = tilemapposinic + ty * tw + tx
    ;ld a, (hl) ;load tile number
    ;and #0b11100000 
    ;;; Si  sale 0 es sólido
    ;jr z, ai_collision
;
    ;ld e, #0x01
;
    ;ret





;ai_Axis_y:
    ;    ;ld a, e_x(ix)
    ;    ;ld b, e_vy(ix)
;
;
    ;    ;;ld a, e_vy(ix)
    ;    ;;bit 7, a
    ;    ;;ld a, e_y(ix)
    ;    ;;jr nz, comprobacion_Y
    ;    ;;add #(e_h - 1) ;;Altura de un enemigo
;
    ;    ld a, e_ia_direction(ix)
    ;    cp #2
    ;    jr z, movimiento_abajo
;
    ;    movimiento_derecha:
    ;        ld a, e_y(ix)
    ;        inc a   ;;Cambiar por la anchura del enemigo
    ;        inc a
    ;        inc a
    ;        inc a   ;;Cambiar por la anchura del enemigo
    ;        inc a
    ;        inc a
    ;        inc a   ;;Cambiar por la anchura del enemigo
    ;        inc a
    ;        inc a
    ;        jr comprobacion_Y
    ;    movimiento_izquierda:
    ;        ld a, e_y(ix)
    ;        dec a   ;;Cambiar por la anchura del enemigo
    ;        dec a
    ;        dec a
    ;        dec a   ;;Cambiar por la anchura del enemigo
    ;        dec a
    ;        dec a
    ;        dec a   ;;Cambiar por la anchura del enemigo
    ;        dec a
    ;        dec a
;
    ;    comprobacion_Y:
    ;        ld c, #0
    ;        call ai_checkEnemyPosition_Y
    ;        ld a, e   ;en e tengo 0 o 1, dependiendo de si ha habido colision, si ya ha habido colision, no hace falta seguir mirando
    ;        cp #0
    ;        jr z, ai_collision   ;;Cambiar direccion del enemigo






