;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "entity.h.s"

.globl size_enemy



;   E_TYPES: INVALID, ALIVE, PLATFORM, ENEMY, 


;   ENTITY SHAPE: TYPE(platform,enemy), X, Y, VX, VY, SPRITE_POINTER(word)
;   ENTITY ARRAY: ALL ENTITIES, ENDS IN INVALID TYPE(0x00)
;   
;
;
;
;

;_man_entity_init::
;    ld hl, #entities
;    ld (m_next_free_entity), hl ;iniciamos la siguiente entidad libre en la primera
;    ld a, (e_type_invalid) ;el ultimo tipo que analice sera invalido siempre
;    ld (fin_entities), a
;    ld a, #0
;    ld (m_num_entities), a
;    ret 
;
;_man_entity_create::  
;    ld bc, (m_next_free_entity) ;cargar el contenido de la posicion donde esta la siguiente entidad libre
;    
;    ld hl, #7        ;cargar el tamaño de la entidad
;    add hl, bc                  ;calcular la posicion de la siguiente entidad libre
;    ld (m_next_free_entity), hl
;    ld a, (e_type_default)
;    ld (bc), a   ;le pone el tipo por defecto al tipo de la entidad
;    ld a, (m_num_entities)
;    inc a               ;incremento del numero de entidades
;    ld (m_num_entities), a 
;
;    ;se devuelve en bc la posicion de la entidad
;    ret
;
;_man_entity_destroy::
;    
;    ;en la pila esta la direccion base de la entidad a borrar
;    ld hl, (m_next_free_entity) ;direccion de la siguiente entidad libre
;    ld bc, #7
;    sbc hl, bc
;    ld (m_next_free_entity), hl     ;next_free = last
;    ;push hl     ;pusheamos la posicion a copiar
;    ;pop bc      ;la pillamos de la pila
;    ;pop hl      ;recuperamos la posicion a borrar
;    pop bc
;    ld a, b
;    cp h
;    jr nz, copiar_memoria
;    ld a, c
;    cp l
;    jr nz, copiar_memoria
;

_man_enemy_forall::
    ld (saltos_forall), hl    ;guardamos la posicion del metodo en memoria

    ;TODO

    ld ix, #enemies       ;load entity array

    en_principio:
        ;TODO
        ld a, (e_type_invalid)  ;cargo el tipo invalido

        ld c, (ix)             ;cargo el tipo de la entidad actual
        or c            ;como el invalido es 0x00, una or que no sea 0, sera valida
        jr z, en_final       ;en el caso de ser falso, salimos del bucle
        ;como si llega aqui, no puede ser 0, saltará siempre
        ld hl, (saltos_forall)  ;cargamos la direccion de salto
        push ix
        ld de, #_en_seguir
        jp (hl)               ;la metemos en la pila para saltar
        ;en ix está la direccion base de la entidad
        _en_seguir::
            pop ix
            ld bc, #19;;#size_enemy   ;el else, mirar la siguiente entidad
            add ix, bc  ;incremento a la siguiente entidad
            jr en_principio
    
    en_final:
        ret

; USAR ESTE METODO A LA HORA DE BORRAR Y CARGAR MAPAS
;recorrer todas las entidades y eliminarlas todas
_destroy_all_entities:
    ret

_man_entity_forall::
    ld (saltos_forall), hl    ;guardamos la posicion del metodo en memoria

    ;TODO

    ;ld ix, #entities       ;load entity array

    fa_principio:
        ;TODO
        ld a, (e_type_invalid)  ;cargo el tipo invalido


        ld c, (ix)              ;cargo el tipo de la entidad actual
        or c            ;como el invalido es 0x00, una or que no sea 0, sera valida
        jr z, fa_final       ;en el caso de ser falso, salimos del bucle
        ;como si llega aqui, no puede ser 0, saltará siempre
        ld hl, (saltos_forall)  ;cargamos la direccion de salto
        jp (hl)               ;la metemos en la pila para saltar
        ;en ix está la direccion base de la entidad
        _fa_seguir::
            ld bc, #7   ;el else, mirar la siguiente entidad
            add ix, bc  ;incremento a la siguiente entidad
            jr fa_principio
    
    fa_final:
        ret


;en hl tiene que llegar la direccion de salto a la funcion
;en a viene la componente a matchear
_man_entity_forall_matching::
    ld (saltos_forall), hl    ;guardamos la posicion del metodo en memoria
    ld (type_for_matching), a
    
    ;TODO, LOAD IN IX THE ENTITY ARRAY THAT WE HAVE TO GO OVER
    ;ld ix, #entities
    
    fa_match_principio:
        ld a, (e_type_invalid)  ;cargo el tipo invalido
        ;LOAD TYPE INVALID TO CHECK END OF ARRAY
        ld c, (ix)              ;CHANGE POSITION IN ARRAY
        or c            ;como el invalido es 0x00, una or que no sea 0, sera valida
        jr z, fa_match_final       ;en el caso de ser falso, salimos del bucle
        ;check if type is equal, to jump to function
        ld a, (type_for_matching)
        ld b, a
        and c
        cp b     ;if its not equal after and, theyre different
        jr nz, _fa_match_seguir      ;if and is zero, not equal type so we check the next entity 
        ;como si llega aqui, no puede ser 0, saltará siempre
        ld hl, (saltos_forall)  ;cargamos la direccion de salto
        jp (hl)               ;la metemos en la pila para saltar
        ;en ix está la direccion base de la entidad
        _fa_match_seguir::
            ld bc, #7   ;CHANGE SIZE OF ENTITY
            add ix, bc  ;incremento a la siguiente entidad
            jr fa_match_principio
    
    fa_match_final:
        ret



;Same as the function above but with iy register
_man_entity_forall_matching_iy::
    ld (saltos_forall_iy), hl    ;guardamos la posicion del metodo en memoria
    ld (type_for_matching_iy), a
    
    ;TODO, LOAD IN IY THE ENTITY ARRAY THAT WE HAVE TO GO OVER
    ;ld iy, #entities
    
    fa_match_principio_iy:
        ld a, (e_type_invalid)  ;cargo el tipo invalido
        ;LOAD TYPE INVALID TO CHECK END OF ARRAY
        ld c, (ix)              ;CHANGE POSITION IN ARRAY
        or c            ;como el invalido es 0x00, una or que no sea 0, sera valida
        jr z, fa_match_final       ;en el caso de ser falso, salimos del bucle
        ;check if type is equal, to jump to function
        ld a, (type_for_matching_iy)
        ld b, a
        and c
        cp b
        jr z, _fa_match_seguir_iy      ;if and is zero, not equal type so we check the next entity 
        ;como si llega aqui, no puede ser 0, saltará siempre
        ld hl, (saltos_forall_iy)  ;cargamos la direccion de salto
        jp (hl)               ;la metemos en la pila para saltar
        ;en ix está la direccion base de la entidad
        _fa_match_seguir_iy::
            ld bc, #7   ;CHANGE SIZE OF ENTITY
            add ix, bc  ;incremento a la siguiente entidad
            jr fa_match_principio_iy
    
    fa_match_final_iy:
        ret