;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;RELOCATE KEYBOARD CHECKS AND VX, VY UPDATES
.include "globalsys.h.s"

.globl player
.globl gravity
.globl menu_manager
.globl reset_pos


;quitamos la direccion de retorno del update_input, y hacemos ret para volver al menu
goBackToMenu:
   ;call cpct_akp_stop_asm
   ;call cpct_waitVSYNC_asm
   call reset_pos
   pop de
   ret


update_input::
    ld ix, #player
    call cpct_scanKeyboard_asm
    
    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    ld playervx(ix), #0xFF
    jr nz, moveLeft

    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    ld playervx(ix), #0x01
    jr nz, moveRight

    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jp nz, goBackToMenu

    ;if none are pressed, we set vx to 0
    ld playervx(ix), #0x00

    continue_input:
      ;reset vy
      ld playervy(ix), #0x00
      ld a, (gravity)
      cp #1
      jr nc, end_routine ;if its 0, no gravity
      
      ld hl, #Key_Q
      call cpct_isKeyPressed_asm
      jp nz, jump ;if w is pressed we check if jump has started
      
      jr movement ;checks if theres any jump in action to update vy


moveLeft:
   ld e, playervx(ix)
   ld a, playerx(ix)
   add a, e
   bit 7, a       ;if screen position is negative, out of bounds
   jr z, continue_input
   ;check the side, to know if it collides with a platform
   ld playervx(ix), #0x00 ;if its not possible to go left
   jr continue_input

moveRight:
   ld e, playervx(ix)
   ld a, playerx(ix)
   add a, e
   cp #77
   jr c, continue_input
   ;check the side, to know if if collides with a platform
   ld playervx(ix), #0x00
   jr continue_input


jump:
   ld a, jump_index(ix)
   cp #0xFF
   jr z, init_jump
   jr movement

init_jump::
   ld a, #0
   ld jump_index(ix),a  ;init jump    
   jr movement


end_jump:
   
   ld jump_index(ix), #0xFF

   ret


movement:

   ld a, jump_index(ix)
   cp #0xFF
   
   jr z, end_routine    ;if theres no jump in action, we end the routine
   
   ld hl, #jump_table
   ld b, #0x00
   ld c, a
   add hl, bc  ;add index, to make movement
   ld b, c
   ld a, (hl)     ;check if jump is finished
   cp #0x80
   jp z, end_jump
   
   ld playervy(ix), a

   inc jump_index(ix)

   end_routine:
      
      ret        
        