;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "globalsys.h.s"
.include "collisions.h.s"


reset_pos_x::   .db #0x00

reset_pos_y::   .db #0x00

cambiomapa:: .db #1

mapa_actual:: .dw  #map_list    ;contador de mapa

map_list:: .dw #_gamemap1
           .db #5, #155   ;; posición inicial
           .db #70, #9   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2
           .dw #_gamemap2
           .db #8, #9   ;; posición inicial
           .db #70, #9   ;; posición cuando resto en array 1
           .db #45, #130   ;; posición cuando resto en array 2
           .dw #_gamemap3
           .db #8, #9   ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2
           .dw #_gamemap4
           .db #60, #11  ;; posición inicial
           .db #5, #168   ;; posición cuando resto en array 1
           .db #70, #168   ;; posición cuando resto en array 2
           .dw #_gamemap5
           .db #70, #168   ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #25, #12   ;; posición cuando resto en array 2
           .dw #_gamemap6
           .db #5, #168   ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2
           .dw #_gamemap7
           .db #50, #14   ;; posición inicial
           .db #8, #135   ;; posición cuando resto en array 1
           .db #50, #160   ;; posición cuando resto en array 2
           .dw #_gamemap8
           .db #70, #135   ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2
           .dw #_gamemap9
           .db #40, #25   ;; posición inicial
           .db #5, #168   ;; posición cuando resto en array 1
           .db #70, #168    ;; posición cuando resto en array 2
           .dw #_gamemap10
           .db #70, #168    ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2
           .dw #_gamemap11
           .db #5, #168   ;; posición inicial
           .db #0x00, #0x00   ;; posición cuando resto en array 1
           .db #0x00, #0x00   ;; posición cuando resto en array 2




change_map_mas_uno::


    ld a, #0x00
    ld playervmem1(ix), a
    ld playervmem2(ix), a
    ld hl, #mapa_actual
    ;de -> posicion en array de mapas
    ld e, (hl)
    inc hl
    ld d, (hl)
    
    ;lo ponemos en hl para añadirle el tamaño de un mapa 8 bytes
    ex de, hl

    ld de, #0x0008
    add hl, de
    
    ;vuelvo a poner la posicion en DE
    ex de, hl
    

    ld hl, #mapa_actual
    ld (hl), e
    inc hl
    ld (hl), d
    ld iy, #0x0000
    add iy, de

    ld a, map_pos_inic_x(iy)
    ld playerx(ix), a
    ld (reset_pos_x), a

    ld a, map_pos_inic_y(iy)
    ld playery(ix), a
    ld (reset_pos_y), a

    ld a, #1
    ld (cambiomapa), a

    ld a, (map_index)
    add a, #1
    ld (map_index), a

    ld e, #0
    ret 

change_map_mas_dos::

    
    ld a, #0x00
    ld playervmem1(ix), a
    ld playervmem2(ix), a
    ld hl, #mapa_actual
    ;de -> posicion en array de mapas
    ld e, (hl)
    inc hl
    ld d, (hl)
    
    ;lo ponemos en hl para añadirle el tamaño de un mapa 8 bytes
    ex de, hl

    ld de, #0x0010
    add hl, de
    
    ;vuelvo a poner la posicion en DE
    ex de, hl
    

    ld hl, #mapa_actual
    ld (hl), e
    inc hl
    ld (hl), d
    ld iy, #0x0000
    add iy, de

    ld a, map_pos_inic_x(iy)
    ld playerx(ix), a
    ld (reset_pos_x), a
    
    ld a, map_pos_inic_y(iy)
    ld playery(ix), a
    ld (reset_pos_y), a
    
    ld a, #1
    ld (cambiomapa), a

    ld a, (map_index)
    add a, #2
    ld (map_index), a


    ld e, #0
    ret 

change_map_menos_uno::



    ld a, #0x00
    ld playervmem1(ix), a
    ld playervmem2(ix), a
    ld hl, #mapa_actual
    ;de -> posicion en array de mapas
    ld e, (hl)
    inc hl
    ld d, (hl)
    
    ;lo ponemos en hl para añadirle el tamaño de un mapa 8 bytes
    ex de, hl

    ld d, #0x00
    ld e, #-8
    ld a, l
    add a, e        ;si la suma no da acarreo, hay que cambiar el valor de h

    call nc, cambiarH

    ld l, a
    ;vuelvo a poner la posicion en DE
    ex de, hl
    

    ld hl, #mapa_actual
    ld (hl), e
    inc hl
    ld (hl), d
    ld iy, #0x0000
    add iy, de

    ld a, map_pos_menos_uno_x(iy)
    ld playerx(ix), a
    ld (reset_pos_x), a

    ld a, map_pos_menos_uno_y(iy)
    ld playery(ix), a
    ld (reset_pos_y), a

    ld a, #1
    ld (cambiomapa), a

    ld a, (map_index)
    add a, #-1
    ld (map_index), a

    ld e, #0

    ret 

cambiarH:
    dec h
    ret

change_map_menos_dos::

    ld a, #0x00
    ld playervmem1(ix), a
    ld playervmem2(ix), a
    ld hl, #mapa_actual
    ;de -> posicion en array de mapas
    ld e, (hl)
    inc hl
    ld d, (hl)
    
    ;lo ponemos en hl para añadirle el tamaño de un mapa 8 bytes
    ex de, hl

    ld d, #0x00
    ld e, #-16
    ld a, l
    add a, e        ;si la suma no da acarreo, hay que cambiar el valor de h

    call nc, cambiarH

    ld l, a
    ;vuelvo a poner la posicion en DE
    ex de, hl
    

    ld hl, #mapa_actual
    ld (hl), e
    inc hl
    ld (hl), d
    ld iy, #0x0000
    add iy, de

    ;cargar la posicion de retorno cuando se viene de dos mapas abajo
    ld a, map_pos_menos_dos_x(iy)
    ld playerx(ix), a
    ld (reset_pos_x), a
    
    ld a, map_pos_menos_dos_y(iy)
    ld playery(ix), a
    ld (reset_pos_y), a

    ld a, #1
    ld (cambiomapa), a

    ld a, (map_index)
    add a, #-2
    ld (map_index), a

    ld e, #0

    ret 