;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "globalsys.h.s"

.globl player
.globl vgravity
.globl gravity


update_enemy_physics:
    ld hl, #update_physics_one_entity
    ;call man_entity_forall
    ret


;UPDATE EVERY ENTITY IN THE ENTITY ARRAY
update_physics_one_entity:
    ret


;update vx and vy in player and every other entity
update_physics::
    
    ld ix, #player
    ld a, playerx(ix)
    add playervx(ix)
    ld playerx(ix), a
    
    ld a, (gravity)
    cp #0
    jr z, checkIfJumpInAction 

    ld a, (vgravity)
    cp #6                  ; MaxGravity = 6 
    jr z, updateY      ;si no es 6, incrementamos 
    inc a
    ld  (vgravity), a
    
    updateY:
        ld a, (vgravity)        ;puede ser 0 u otra cosa, dependiendo de si esta activada la gravity o no
        ld c, playervy(ix)
        add c
        ld playervy(ix), a
        add playery(ix)
        ld  playery(ix), a

    call update_enemy_physics

    ret


checkIfJumpInAction:
    ld a, jump_index(ix)
    cp #0xFF
    jr nz, updateVyWithoutGravity
    ;si no hay un salto en accion y la gravedad es 0, esta en una plataforma
    ld a, #0x01
    ld playervy(ix), a
    add playery(ix)
    ld playery(ix), a

    ret

updateVyWithoutGravity:
    ld a, playervy(ix)
    add playery(ix)
    ld playery(ix), a
    ret



