;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Jump Maniac: An Amstrad CPC Game 
;;  Copyright (C) 2021 - Sprite Lab Enterprise (@spriteLab)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  Jump Maniac is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "globalsys.h.s"

.globl mapa_actual
.globl cambiomapa
.globl set_map_enemies

.globl _key_music
.globl _finalKey_music

.globl get_player_animation
.globl cpct_waitVSYNC_asm
.globl key_status
.globl map_index
.globl _spr_key_0
.globl _screen_endgame_z_end
.globl _EG_palette
.globl endgame_manager
.globl key_map6
.globl _spr_player_0
.globl key_map8
.globl key_map11
.globl reset_pos_x
.globl reset_pos_y
.globl player
.globl _man_enemy_forall
.globl _spr_enemy_0
.globl get_enemy_animation

palette: .db HW_BLACK, HW_BRIGHT_WHITE
         .db HW_BRIGHT_RED , HW_BRIGHT_RED
         .db HW_ORANGE, HW_ORANGE
         .db HW_BRIGHT_YELLOW, HW_BRIGHT_YELLOW
         .db HW_BRIGHT_GREEN, HW_BRIGHT_GREEN
         .db HW_SKY_BLUE, HW_SKY_BLUE
         .db HW_BLUE, HW_BLUE
         .db HW_MAUVE, HW_MAUVE

sys_render_init::
   call cpct_disableFirmware_asm
   ld c, #0
   call cpct_setVideoMode_asm
   ld l, #16
   ld h, #HW_BRIGHT_WHITE
   call cpct_setPALColour_asm ;setBorder
   
   ret

change_palette::
   ld hl, #palette
   ld de, #16
   call cpct_setPalette_asm
   ret


set_map::
   
   update_map:
   ld de, #0xC000
   ld c, playerx(ix)
   ld b, playery(ix)
   call cpct_getScreenPtr_asm
   ex de, hl
   push de
   ld c, #24
   ld b, #4

   ;devuelve en hl el sprite a printear
   ;call get_player_animation
   ld hl, #_spr_player_0
   pop de

   call cpct_drawSpriteBlended_asm
   
   call printMap

   call set_map_enemies
   ld a, (map_index)
   cp #6
   jr nz, next   
   ld iy, #key_map6
   ld a, 4(iy)
   cp #1
   ;si key_status != 1, no dibujar la llave
   ret nz

   call draw_key
   next:
   
   ld a, (map_index)
   cp #8
   jr nz, last   
   ld iy, #key_map8
   ld a, 4(iy)
   cp #1
   ;si key_status != 1, no dibujar la llave
   ret nz
;
   call draw_key

   last:

   ld a, (map_index)
   cp #11
   ret nz   
   ld iy, #key_map11
   ld a, 4(iy)
   cp #1
   ;si key_status != 1, no dibujar la llave
   ret nz
;
   call draw_key

   
   ret



end_screen::

   ld hl, #_EG_palette
   ld de, #16
   call cpct_setPalette_asm


   ld  hl, #_screen_endgame_z_end
   ld  de, #0xFFFF
   call  cpct_zx7b_decrunch_s_asm

   jump_to_endgame:
      pop de ;quitar el call de update_render para volver al menu manager y tal
      jp endgame_manager


draw_key::


   ld de, #0xC000
   ld c, 0(iy) ;pos x, key
   ld b, 1(iy) ;pos y, key
   call cpct_getScreenPtr_asm ;devuelve en hl la posicion de la pantalla
   ex de, hl
   ld l, 5(iy)
   ld h, 6(iy)
   ;ld hl, #_spr_key2_0
   ld b, 2(iy) ;ancho key
   ld c, 3(iy) ;alto key
   call cpct_drawSpriteBlended_asm

   ret


printMap::

   ;;;;DESCOMPRESIÓN DEL MAPA
   ;;ld de, #0xFFFF ;; final de la memoria de vídeo
   ;;ld hl, #_gamemap1_end
   ;;call cpct_zx7b_decrunch_s_asm
   ;; width in tiles
   ;;call cpct_clearScreen_asm
   ld c, #20
   ;; height in tiles
   ld b, #25
   ;; tilemap width
   ld de, #20
   ;; tileset
   ld hl, #_tileset_00
   call cpct_etm_setDrawTilemap4x8_ag_asm

   ;; where to draw
   call givememap
   ;ld de, #_gamemap9
   ;; tilemap
   ld hl, #0xC000
   call cpct_etm_drawTilemap4x8_ag_asm

   ld a, #0
   ld (cambiomapa), a

   ret


givememap::

   ld hl, #mapa_actual

   ;meter en DE la direccion dentro del array de mapas
   ld e, (hl)
   inc hl
   ld d, (hl)
   
   ;cambiar de DE a HL la posicion del array de mapas
   ex de, hl
   
   ld e, (hl)
   inc hl
   ld d, (hl)

   
   ret


update_render::
   ;;load pvmem
   ;; TODO CREAR VARIABLE QUE CONTROLE SI HAY QUE RECARGAR EL MAPA
   ld ix, #player
   ld a, (cambiomapa)
   cp #0
   jp nz, set_map
   
   call reset_pos

   ld de, #0xC000
   ld c, playerx(ix)
   ld b, playery(ix)
   call cpct_getScreenPtr_asm ;returns in hl screen pointer
   ;;save current value for next iteration
   ld playervmem2(ix), l
   ld playervmem1(ix), h
   ex de, hl
   push de
   ;;ld a, 2(ix)
   ;;ld b, #8
   ;;ld c, #2
   ;;call cpct_drawSolidBox_asm
   
   call get_player_animation
   ld c, #24
   ld b, #4
   ;ld hl, #_spr_char
   pop de
   call cpct_drawSpriteBlended_asm
   
   ld a, (cambiomapa)
   cp #0
   jp nz, printMap

   call enemies_render_update
   ret


reset_pos::

   ld d, playervmem1(ix)
   ld e, playervmem2(ix)
   
   ld c, #24
   ld b, #4

   ld h, playersprite_l(ix)
   ld l, playersprite_l + 1(ix)
   
   
   call cpct_drawSpriteBlended_asm
   ret


enemies_render_update:
   ld hl, #render_enemies
   call _man_enemy_forall
   ret

;recibe en ix, la direccion del enemigo
render_enemies:
   push de
   call reset_enemy_pos
   
   ld de, #0xC000
   ld c, 0(ix)
   ld b, 1(ix)
   call cpct_getScreenPtr_asm ;returns in hl screen pointer
   ;;save current value for next iteration
   ld 18(ix), l
   ld 17(ix), h
   ex de, hl
   push de
   
   ;ld hl, #_spr_enemy_0
   call get_enemy_animation
   ;cambiar ancho y alto
   ld c, #4
   ld b, #5

   pop de
   call cpct_drawSpriteBlended_asm
   
   pop hl
   jp (hl)

   ret

reset_enemy_pos::
   ld d, 17(ix)
   ld e, 18(ix)
   
   ld c, #4
   ld b, #5
   
   ld l, 16(ix)
   ld h, 15(ix)
   
   call cpct_drawSpriteBlended_asm
   
   ret


draw_muerte::
   ld d, playervmem1(ix)
   ld e, playervmem2(ix)
   ;;
   ld c, #24
   ld b, #4

   ld hl, #_spr_player_7
   
   ;;ld h, playersprite_l(ix)
   ;;ld l, playersprite_l + 1(ix)
   
   
   call cpct_drawSpriteBlended_asm
   ret


   

deleteAndResetPlayer::
   
   call reset_pos

   call bucleVSync

   ;; Pinto el sprite de muerte
   call draw_muerte
   ;;call reset_pos


   call bucleVSync

   call draw_muerte
   

   ld de, #0xC000
   ld a, (reset_pos_x)
   ld c, a
   ld playerx(ix), c

   ld a, (reset_pos_y)
   ld b, a
   ld playery(ix), b
   call cpct_getScreenPtr_asm ;returns in hl screen pointer
   ;;save current value for next iteration
   ld playervmem2(ix), l
   ld playervmem1(ix), h

   push hl

  
   call get_player_animation
   ld c, #24
   ld b, #4
   pop de
   call cpct_drawSpriteBlended_asm

   ret



bucleVSync:
   ld e, #0xFF
      loop:
         call cpct_waitVSYNC_asm
         dec e
         jr nz, loop

   ld e, #0x40
   secondLoop:
      call cpct_waitVSYNC_asm
      dec e
      jr nz, secondLoop

ret